% Tomasz P. Zieliski "Cyfrowe przetwarzanie sygnaw"
% --------------------------------------
% Tabela 4-2 (str. 101)
% wiczenie - Twierdzenie o prbkowaniu
% --------------------------------------

% 1. Jeli czstotliwo prbkowania sygnau analogowego jest wicej ni dwa razy wiksza 
%    od czstotliwoci maksymalnej sygnau, to z sygnau sprbkowanego (cyfrowego)
%    mona dokadnie odtworzy sygna analogowy.
% 2. Przejcie z czstotliwoci fps (wiksza) na fpn (mniejsza) i powrt,
%    czyli odtworzenie synau

% fps/fpn = K = liczba cakowita  ==> fpn=fps/K > 2

  clear all; clf; hold off; 

  fx  = 1;		% czstotliwo sygnau [Hz] 
  fps = 100;	% stara czstotliwo prbkowania [Hz] 
  N = 200;		% liczba prbek sygnau sprbkowanego z czstotliwoci fps (stara) 
  K = 10;		% ile razy zmniejszy czstotliwo prbkowania

% Generacja sygnau sprbkowanego z czstotliwoci fps

  dts = 1/fps;	% stary okres prbkowania

  ts = 0 : dts : (N-1)*dts; 
  xs = sin(2*pi*fx*ts); 
  plot(ts,xs,'r',ts,xs,'o'); grid; title('Sygnal sprobkowany - fp STARE'); pause

% Przejcie z czstotliwoci wikszej na mniejsz: xs(n) -> xn(n) 

  fpn = fps/K;	% nowa czstotliwo prbkowania = zmniejszona stara czstotliwo

  xn = xs( 1 : K : length(xs) ); 
  M = length(xn); 
  dtn = K*dts; 
  tn = 0 : dtn : (M-1)*dtn; 
  plot(ts,xs,'r',tn,xn,'o'); grid; title('Sygnal sprobkowany - fp NOWE'); pause
  plot(tn,xn,'b',tn,xn,'o'); grid; title('Sygnal sprobkowany - fp NOWE'); pause
  stem(xn,'b'); title('Sygnal sprobkowany - fp NOWE'); pause

% Powrt z czstotliwoci mniejszej na wiksz: xn(n) -> y(n) 

  % Funkcja aproksymujca
  
  t = -(N-1)*dts : dts : (N-1)*dts;		% czas trwania funkcji aproksymujcej
  f = 1/(2*dtn);								% czstotliwo "zer" w funkcji aproksymujcej
  fa = sin(2*pi*f*t)./(2*pi*f*t);		% funkcja aproksymujca
  fa(N)=1;										% warto w zerze (dzielenie 0/0) 
  tz = [ -fliplr(tn) tn(2:M)];			%
  z = [zeros(1,M-1) 1 zeros(1,M-1)];	%
  
  plot(t,fa,'b',tz,z,'o'); grid; title('Sinc - funkcja aproksymujaca'); pause
  
  % Aproksymacja
  
  y = zeros(1,N); 
  ty = 0 : dts : (N-1)*dts; 
  
  for k = 1 : M
     fa1 = fa( (N)-(k-1)*K : (2*N-1)-(k-1)*K ); 
     y1 = xn(k) * fa1; 
     y = y + y1; 
     subplot(311); plot(ty,fa1); grid; title('Kolejna funkcja aproksymujaca'); 
     subplot(312); plot(ty,y1);  grid; title('Kolejny skladnik sumy'); 
     subplot(313); plot(ty,y);   grid; title('Suma'); 
     pause
  end
  
  subplot(111); 
  
  plot(ty,y,'b'); grid; title('Sygnal odtworzony'); pause
  plot(ty,xs(1:N)-y(1:N),'b'); grid; title('Roznica miedzy sygnalami'); pause
